glibmm: Gio::Seekable Class Reference

glibmm 2.36.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::Seekable Class Reference
Stream Classes

Stream seeking interface. More...

`#include <giomm/seekable.h>`

Inheritance diagram for Gio::Seekable:
[legend]

## Public Member Functions
virtual | ~Seekable ()
GSeekable* | gobj ()
| Provides access to the underlying C GObject.
const GSeekable* | gobj () const
| Provides access to the underlying C GObject.
goffset | tell () const
| Tells the current position within the stream.
bool | can_seek () const
| Tests if the stream supports the SeekableIface.
bool | seek (goffset offset, Glib::SeekType type, const Glib::RefPtr< Cancellable >& cancellable)
| Seeks in the stream by the given offset, modified by type.
bool | seek (goffset offset, Glib::SeekType type)
| A seek() convenience overload.
bool | can_truncate () const
| Tests if the stream can be truncated.
bool | truncate (goffset offset, const Glib::RefPtr< Cancellable >& cancellable)
| Truncates a stream with a given #offset.
bool | truncate (goffset offset)
| A truncate() convenience overload.
Public Member Functions inherited from Glib::Interface
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes.
| Interface (GObject* castitem)
| Called by constructors of derived classes.
virtual | ~Interface ()
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable ()
| trackable (const trackable &src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| Seekable ()
| You should derive from this class to use it.

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::Seekable > | wrap (GSeekable* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Stream seeking interface.

Seekable is implemented by streams (implementations of InputStream or OutputStream) that support seeking. To find the position of a stream, use tell(). To find out if a stream supports seeking, use can_seek(). To position a stream, use seek(). To find out if a stream supports truncating, use can_truncate(). To truncate a stream, use truncate().

Since glibmm 2.16:

## Constructor & Destructor Documentation

Gio::Seekable::Seekable | ( |  | ) |
| protected

You should derive from this class to use it.

virtual Gio::Seekable::~Seekable | ( |  | ) |
| virtual

## Member Function Documentation

static void Gio::Seekable::add_interface | ( | GType | gtype_implementer | ) |
| static

bool Gio::Seekable::can_seek | ( |  | ) | const

Tests if the stream supports the SeekableIface.

Returns
  `true` if seekable can be seeked. `false` otherwise.

bool Gio::Seekable::can_truncate | ( |  | ) | const

Tests if the stream can be truncated.

Returns
  `true` if the stream can be truncated, `false` otherwise.

static GType Gio::Seekable::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

Reimplemented in Gio::MemoryOutputStream, Gio::FileOutputStream, Gio::FileInputStream, Gio::FileIOStream, and Gio::MemoryInputStream.

GSeekable* Gio::Seekable::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gio::MemoryOutputStream, Gio::FileOutputStream, Gio::FileInputStream, Gio::FileIOStream, and Gio::MemoryInputStream.

const GSeekable* Gio::Seekable::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gio::MemoryOutputStream, Gio::FileOutputStream, Gio::FileInputStream, Gio::FileIOStream, and Gio::MemoryInputStream.

bool Gio::Seekable::seek | ( | goffset | offset,
|  | Glib::SeekType | type,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Seeks in the stream by the given offset, modified by type.

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters

  offset | A #goffset.
  type | A SeekType.
  cancellable | Cancellable object.

Returns
  `true` if successful. If an error has occurred, this function will return `false` and set error appropriately if present.

bool Gio::Seekable::seek | ( | goffset | offset,
|  | Glib::SeekType | type
| ) |  |

A seek() convenience overload.

goffset Gio::Seekable::tell | ( |  | ) | const

Tells the current position within the stream.

Returns
  The offset from the beginning of the buffer.

bool Gio::Seekable::truncate | ( | goffset | offset,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Truncates a stream with a given #offset.

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED. If an operation was partially finished when the operation was cancelled the partial result will be returned, without an error.

Parameters

  offset | A #goffset.
  cancellable | Cancellable object.

Returns
  `true` if successful. If an error has occurred, this function will return `false` and set error appropriately if present.

bool Gio::Seekable::truncate | ( | goffset | offset | ) |

A truncate() convenience overload.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::Seekable > wrap | ( | GSeekable * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.